
////////////////////////////////////////////////////////////////////////////////
// 
// txt2pdf.h
//                                                                (C) 2003 PAPY
//                                             http://homepage1.nifty.com/MADIA/
//
//////////////////////////////////////////////////////////////////////////////// 

/* -------------- Support Japanese charcode "ShiftJIS" Only! ---------------- */

#ifndef __TXT2PDF_H__
#define __TXT2PDF_H__

#include <stdio.h>
#include <malloc.h>
#include <string.h>

typedef int                 BOOL;
typedef unsigned char       BYTE;
typedef unsigned short      WORD;
typedef unsigned long       DWORD;

#define FALSE               0
#define TRUE                1

#define PDF_ERROR_NOMEMORY     "mۂł܂łB" 
#define PDF_ERROR_ZERO         "TCY0ɂ͂ł܂B" 
#define PDF_ERROR_INDEXOVER    "CfbNX̎w肪słB" 
#define PDF_ERROR_FILEREAD     "t@C̓ǂݍ݂Ɏs܂B"
#define PDF_ERROR_FILECREATE   "t@C̍쐬Ɏs܂B" 
#define PDF_ERROR_FILEPOINTER  "t@C|C^łB" 
#define PDF_ERROR_UNKNOWN      "\ʗO܂B" 

////////////////////////////////////////////////////////////////////////////////
//   CPList (|C^Xg)
////////////////////////////////////////////////////////////////////////////////
class CPList
{
  private:
     DWORD *FBuffer;
     int    FCount;
  protected:
  public:
     CPList(); 
     ~CPList();   
     void* operator[]( int Index );
     void* Get(int Index) const;
     int   Count()        const;     
     void  Add(void *P);    
     void  Clear();                 
};

////////////////////////////////////////////////////////////////////////////////
//   CPStringList (񃊃Xg)
////////////////////////////////////////////////////////////////////////////////
class CPStringList
{
  private:
     CPList *FBuffer;
  protected:
  public: 
      CPStringList(); 
      CPStringList(const CPStringList& Value); 
     ~CPStringList();   
     const char*  operator[]( int Index );
     CPStringList& operator=(const CPStringList& Value);
     CPStringList& Assign(const CPStringList &Source); 
     void  Add(const char* S);
     const char* Get(int Index) const;
     int   Count()              const;     
     void  Clear();
     void  LoadFromFile(FILE *AStream);
     void  LoadFromFile(const char* Filename);
     void  SaveToFile(FILE *AStream,const char* LineFeed="\r\n")        const;
     void  SaveToFile(const char* Filename,const char* LineFeed="\r\n") const;
};

////////////////////////////////////////////////////////////////////////////////
//   CPDFObjMemManager (ݎQƃe[u) [ p ]
////////////////////////////////////////////////////////////////////////////////
class CPDFObjMemManager
{
  private:
     DWORD *FBuffer;
     DWORD FObjectCount;
     DWORD FReallocCount;
  protected:
  public:
     DWORD ObjectIndex;
     DWORD *ObjectPosArray;
     CPDFObjMemManager(DWORD ObjectCount=1000, DWORD ReallocCount=1000); 
     ~CPDFObjMemManager();   
     void MemoryCheck();              
};

////////////////////////////////////////////////////////////////////////////////
//   CTxt2pdf (eLXgPDFϊ)
////////////////////////////////////////////////////////////////////////////////
class CTxt2pdf
{
  private:      
     WORD m_PageWidth;    
     WORD m_PageHeight;      
     BYTE m_MarginX ;        
     BYTE m_MarginY ;       
     BYTE m_FontSize;       
     char *m_FontEncoding;   
     char *m_FontWidth;      
     char *m_FontName;       
     void AsciiHexEncoding(FILE *AStream,const char *S);
     void Write_CrossReferenceTable(FILE *AStream,DWORD ObjectPosArray[],DWORD Count);
     void DrawText(FILE *AStream,int x,int y,CPStringList &Lines);
     int  GetTextWidth(const char* S);
     void AutoLineFeed(CPStringList &Lines);
     void Write_PageObject(FILE *AStream,CPDFObjMemManager &ObjectMem, CPStringList &Lines,CPStringList &PageList);
  protected:
  public:
     void txt2pdf(FILE *Input,FILE *Output,WORD PageWidth = 595,  // p̉TCY
                                           WORD PageHeight= 842,  // p̏cTCY
                                           BYTE MarginX   =  30,  // ] ( )
                                           BYTE MarginY   =  30,  // ] ( )
                                           BYTE FontSize  =  12); // tHg̃TCY (1-100炢܂)
     void txt2pdf(const char *OpenName,const char *SaveName,WORD PageWidth = 595,   // p̉TCY
                                                            WORD PageHeight= 842,   // p̏cTCY
                                                            BYTE MarginX   =  30,   // ] ( )
                                                            BYTE MarginY   =  30,   // ] ( )
                                                            BYTE FontSize  =  12);  // tHg̃TCY (1-100炢܂)
};

// ---------------------------
// pTCYƃ|Cg̊֌W
// ---------------------------
//  A3 842x1191  297x420mm
//  A4 595x842   210x297mm
//  A5 420x595   148x210mm
//  B4 729x1032  257x364mm
//  B5 516x729   182x257mm
// ---------------------------

#endif // __TXT2PDF_H__